quickie_svt(1)

NAME
quickie_svt - simple version tool

SYNOPSIS
quickie_svt -Check_Output -History file -File output-file [ -e edit ]
quickie_svt -Check_In -History file -File input-file
quickie_svt -List -History file
quickie_svt -Query -History file
quickie_svt -Version

DESCRIPTION
The quickie_svt program is used to manage Quickie's history version files. Normally the quickie(1) CGI progran does this by itself, but there may be times when a maintainer needs to access the history directly. (It's also useful for testing.)

OPTIONS
The following options are understood:

-History history-file
    This option is used to specify the name of the history file. The usual suffix is ",svt".

-File file-name
    This option is used to specify the name of the input or output file. On checkout, the file name "-" is understood to mean the standard output. There is no equivalent for checkin.

-Edit edit-number
    This option is used to specify the edit number (version number). On checkout, if no version number is specified, the most recent version is given.

-Check_In
    This option is used to check a file into the history.

-Check_Out
    This option is used to checkout a file from the history.

-List
    This option is used to list the file's history.

-Query
    This option is used to query edit number of most recent checkin.

-Version
    This option is used to print version number.

All other options will produce a diagnostic error.

All options may be abbreviated; the abbreviation is documented as the upper case letters, all lower case letters and underscores (_) are optional. You must use consecutive sequences of optional letters.

All options are case insensitive, you may type them in upper case or lower case or a combination of both, case is not important.

For example: the arguments "-project, "-PROJ" and "-p" are all interpreted to mean the -Project option. The argument "-prj" will not be understood, because consecutive optional characters were not supplied.

Options and other command line arguments may be mixed arbitrarily on the command line, after the function selectors.

The GNU long option names are understood. Since all option names for quickie_svt are long, this means ignoring the extra leading '-'. The "--option=value" convention is also understood.

FILE FORMAT
Each version in the history file consists of an RFC822 header, plus the file contents. The header includes (at least) the Content-Length, used to remember the length of the file data in bytes; the Checksum, used to remember the Adler32 checksum of the file data; and Version, used to remember the version number. The file data can be text or binary, because its length is determined by the header. There is no quoting mechanism of any kind for the data. Except for the mandatory fields, additional user-defined us-ascii meta-data may also be stored in the header. There is no diff or delta of any kind for any version.

This combination of header and data has good end-to-end behaviour, because there is a checksum to validate the file data against. Bad blocks in the data will be detected then next time a checkin or checkout is attempted.

The format of the history file consists of one or more file versions with the above layout, joined head-to-tail with no separators or boundary indicators of any kind. The versions are in descending order, from most recent (greatest edit number) to least recent (version number one). To determine where one version stops and the next version starts, use the Content-Length field in the header. The entire history file is then compressed using the GNU Zip algorithm (via zlib). There is no diff or delta of any kind in the history file.

The advantage of compressing the file is that there is usually a very high redundancy between file versions. For example, if two identical versions are checked in (not necessarily sequentially) the second copy will compress to only a few bytes. Unlike diff(1) style deltas, this also copes very will with moving blocks of data within the file. The use of GNU Zip formatting means there is also a checksum for the whole history file, which allows you to detect bad blocks in the header portions; it also means there is a simple way to extract the data from a history file even without the quickie_svt program, or for testing, or because you are curious.

This style of history file was inspired by RFC 3284 - The VCDIFF Generic Differencing and Compression Data Format. While the quickie_svt format does not use RFC3284 internally, the arguments for compression across file versions in still relevant.

EXIT STATUS
The quickie_svt command will exit with a status of 1 on any error. The quickie_svt command will only exit with a status of 0 if there are no errors.

COPYRIGHT
quickie_svt version 1.1
Copyright (C) 2005, 2006 Peter Miller;
All rights reserved.

The quickie_svt program comes with ABSOLUTELY NO WARRANTY; for details use the 'quickie_svt -VERSion License' command. This is free software and you are welcome to redistribute it under certain conditions; for details use the 'quickie_svt -VERSion License' command.

AUTHOR
Peter Miller | E-Mail: | millerp@canb.auug.org.au
/\/\* | WWW: | http://www.canb.auug.org.au/~millerp/